package com.ctg.ag.sdk.core.http;

package ..deTemp.1736056324136;

import com.ctg.ag.sdk.core.HttpClient;
import com.ctg.ag.sdk.core.exception.SdkClientException;
import com.ctg.ag.sdk.core.model.BuilderParams;
import java.lang.reflect.Constructor;

public class HttpClientFactory {
  public static String HTTP_CLIENT_IMPL_KEY = "Telecom API Gateway Java SDK SDK Httpclient";
  
  public static String DEFAULT_HTTP_CLIENT = "com.ctg.ag.sdk.core.http.ApacheHttpClient";
  
  public static HttpClient buildClient(BuilderParams builderParams) {
    try {
      String httpClientClassName = System.getProperty(HTTP_CLIENT_IMPL_KEY);
      if (httpClientClassName == null || httpClientClassName.isEmpty())
        httpClientClassName = DEFAULT_HTTP_CLIENT; 
      Class<?> httpClientClass = Class.forName(httpClientClassName);
      if (!HttpClient.class.isAssignableFrom(httpClientClass))
        throw new IllegalStateException(String.format("%s is not assignable from HttpClient", new Object[] { httpClientClassName })); 
      Constructor<? extends HttpClient> constructor = (Constructor)httpClientClass.getConstructor(new Class[] { BuilderParams.class });
      return constructor.newInstance(new Object[] { builderParams });
    } catch (Exception e) {
      throw new SdkClientException("HttpClientFactory buildClient failed", e);
    } 
  }
}
